import React from 'react';
import { Element, NodeEntry, Range, Text, Mark } from 'slate';
import { Leaf } from '../utils/leaf';
/**
 * `RenderDecorationProps` are passed to the `renderDecoration` handler.
 */
export interface RenderDecorationProps {
    children: any;
    decoration: Range;
    leaf: Leaf;
    text: Text;
    attributes: {
        'data-slate-decoration': true;
    };
}
/**
 * `RenderElementProps` are passed to the `renderElement` handler.
 */
export interface RenderElementProps {
    children: any;
    element: Element;
    attributes: {
        'data-slate-inline'?: true;
        'data-slate-node': 'element';
        'data-slate-void'?: true;
        dir?: 'rtl';
        ref: any;
    };
}
/**
 * `RenderMarkProps` are passed to the `renderMark` handler.
 */
export interface RenderMarkProps {
    children: any;
    mark: Mark;
    leaf: Leaf;
    text: Text;
    attributes: {
        'data-slate-mark': true;
    };
}
/**
 * Editable.
 */
export declare const Editable: (props: {
    decorate?: ((entry: NodeEntry) => Range[]) | undefined;
    onDOMBeforeInput?: ((event: Event) => void) | undefined;
    placeholder?: string | undefined;
    readOnly?: boolean | undefined;
    role?: string | undefined;
    style?: React.CSSProperties | undefined;
    renderDecoration?: ((props: RenderDecorationProps) => JSX.Element) | undefined;
    renderElement?: ((props: RenderElementProps) => JSX.Element) | undefined;
    renderMark?: ((props: RenderMarkProps) => JSX.Element) | undefined;
} & React.TextareaHTMLAttributes<HTMLDivElement>) => JSX.Element;
//# sourceMappingURL=editable.d.ts.map